<template lang="pug">
div
	q-breadcrumbs(gutter="sm").q-mb-lg
		q-breadcrumbs-el(icon="home" to="/")
		q-breadcrumbs-el(label="Кухня" to="/kitchen")
		q-breadcrumbs-el(label="Ингредиенты" to="/kitchen/dishtypes")
		q-breadcrumbs-el(:label="newItem ? 'Новый тип блюда' : 'Редактирование типа блюда'")

	.inner.q-py-md
		q-form.q-gutter-md(@submit="onSubmit")
			ui-input-text(v-model="item.name", label="Название типа", required, :loading="loading")

			ui-input-text(
				v-model="item.color",
				label="Цвет",
				required,
				:rules="['hexColor']"
				:loading="loading"
				)
				template(#append)
					q-icon.cursor-pointer(name="colorize")
						q-popup-proxy(transition-show="scale", transition-hide="scale")
							q-color(
								v-model="item.color"
								no-footer
								)

			ui-uploader-image(
				v-model="item.visual",
				label="Изображение",
				:rules="[ val => val && val.length > 0 || 'Необходимо добавить изображение типа']"
			)

			q-btn(
				:label="newItem ? 'Добавить новый тип' : 'Сохранить тип'",
				type="submit",
				color="primary"
				:loading="loading"
			)


</template>

<script lang="ts">
	import { defineComponent, onMounted, ref, computed } from 'vue'
	import { mapWritableState } from 'pinia'
	import { IDishType } from '@/plugins/utils/types'
	import { useRouter } from 'vue-router'
	import UiUploaderImage from '@/components/ui/UiUploaderImage.vue'
	import UiInputText from '@/components/ui/UiInputText.vue'
	import { useKitchenDishTypesStore } from '@/pages/kitchen/children/dishtypes/store'
	import { useQuasar } from 'quasar'

	export default defineComponent({
		name: 'PageKitchenDishTypesItem',

		props: ['id'],

		components: {
			UiUploaderImage,
			UiInputText,
		},

		setup(props) {
			const $q = useQuasar()
			const newItem = ref(props.id === undefined)
			const store = useKitchenDishTypesStore()
			const router = useRouter()

			onMounted(() => {
				store.getDishTypeById(props.id)
			})

			return {
				newItem,
				loading: computed(() => store.loading),
				async onSubmit() {
					const { id } = (await store.saveDishTypeItem()) as IDishType
					await router.push(`/kitchen/dishtypes/${id}`)
					$q.notify({
						color: 'positive',
						message: newItem.value ? 'Новый тип добавлен' : 'Изменения сохранены',
					})
				},
			}
		},

		computed: {
			...mapWritableState(useKitchenDishTypesStore, {
				item: 'item',
			}),
		},
	})
</script>
